Makefile 6.5 KB
Newer Older
L
Linus Torvalds 已提交
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20
# Makefile for the different targets used to generate full packages of a kernel
# It uses the generic clean infrastructure of kbuild

# RPM target
# ---------------------------------------------------------------------------
# The rpm target generates two rpm files:
# /usr/src/packages/SRPMS/kernel-2.6.7rc2-1.src.rpm
# /usr/src/packages/RPMS/i386/kernel-2.6.7rc2-1.<arch>.rpm
# The src.rpm files includes all source for the kernel being built
# The <arch>.rpm includes kernel configuration, modules etc.
#
# Process to create the rpm files
# a) clean the kernel
# b) Generate .spec file
# c) Build a tar ball, using symlink to make kernel version
#    first entry in the path
# d) and pack the result to a tar.gz file
# e) generate the rpm files, based on kernel.spec
# - Use /. to avoid tar packing just the symlink

21 22 23
# Note that the rpm-pkg target cannot be used with KBUILD_OUTPUT,
# but the binrpm-pkg target can; for some reason O= gets ignored.

L
Linus Torvalds 已提交
24
# Remove hyphens since they have special meaning in RPM filenames
25
KERNELPATH := kernel-$(subst -,_,$(KERNELRELEASE))
R
Riku Voipio 已提交
26 27
KDEB_SOURCENAME ?= linux-$(KERNELRELEASE)
export KDEB_SOURCENAME
28
# Include only those top-level files that are needed by make, plus the GPL copy
29
TAR_CONTENT := $(KBUILD_ALLDIRS) .config .scmversion Makefile \
30
               Kbuild Kconfig COPYING $(wildcard localversion*)
L
Linus Torvalds 已提交
31 32
MKSPEC     := $(srctree)/scripts/package/mkspec

33 34
quiet_cmd_src_tar = TAR     $(2).tar.gz
      cmd_src_tar = \
35
set -e; \
36
if test "$(objtree)" != "$(srctree)"; then \
37 38 39 40 41 42
	echo >&2; \
	echo >&2 "  ERROR:"; \
	echo >&2 "  Building source tarball is not possible outside the"; \
	echo >&2 "  kernel source tree. Don't set KBUILD_OUTPUT, or use the"; \
	echo >&2 "  binrpm-pkg or bindeb-pkg target instead."; \
	echo >&2; \
43 44 45 46
	false; \
fi ; \
$(srctree)/scripts/setlocalversion --save-scmversion; \
tar -cz $(RCS_TAR_IGNORE) -f $(2).tar.gz \
47 48
	--transform 's:^:$(2)/:S' $(TAR_CONTENT) $(3); \
rm -f $(objtree)/.scmversion
49

L
Linus Torvalds 已提交
50
# rpm-pkg
S
Sam Ravnborg 已提交
51
# ---------------------------------------------------------------------------
52
rpm-pkg: FORCE
L
Linus Torvalds 已提交
53
	$(MAKE) clean
54
	$(CONFIG_SHELL) $(MKSPEC) >$(objtree)/kernel.spec
55
	$(call cmd,src_tar,$(KERNELPATH),kernel.spec)
56 57
	+rpmbuild $(RPMOPTS) --target $(UTS_MACHINE) -ta $(KERNELPATH).tar.gz \
	--define='_smp_mflags %{nil}'
L
Linus Torvalds 已提交
58 59

# binrpm-pkg
S
Sam Ravnborg 已提交
60
# ---------------------------------------------------------------------------
61
binrpm-pkg: FORCE
62
	$(MAKE) KBUILD_SRC=
63
	$(CONFIG_SHELL) $(MKSPEC) prebuilt > $(objtree)/binkernel.spec
64
	+rpmbuild $(RPMOPTS) --define "_builddir $(objtree)" --target \
65
		$(UTS_MACHINE) -bb $(objtree)/binkernel.spec
66 67

clean-files += $(objtree)/*.spec
L
Linus Torvalds 已提交
68 69 70

# Deb target
# ---------------------------------------------------------------------------
71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86
quiet_cmd_builddeb = BUILDDEB
      cmd_builddeb = set -e; \
	test `id -u` = 0 || \
	test -n "$(KBUILD_PKG_ROOTCMD)" || { \
		which fakeroot >/dev/null 2>&1 && \
		KBUILD_PKG_ROOTCMD="fakeroot -u"; \
	} || { \
		echo; \
		echo "builddeb must be run as root (or using fakeroot)."; \
		echo "KBUILD_PKG_ROOTCMD is unset and fakeroot not found."; \
		echo "Try setting KBUILD_PKG_ROOTCMD to a command to acquire"; \
		echo "root privileges (e.g., 'fakeroot -u' or 'sudo')."; \
		false; \
	} && \
	\
	$$KBUILD_PKG_ROOTCMD $(CONFIG_SHELL) \
R
Riku Voipio 已提交
87
		$(srctree)/scripts/package/builddeb $@
88

S
Sam Ravnborg 已提交
89
deb-pkg: FORCE
R
Riku Voipio 已提交
90 91 92 93 94 95
	$(MAKE) clean
	$(call cmd,src_tar,$(KDEB_SOURCENAME))
	$(MAKE) KBUILD_SRC=
	+$(call cmd,builddeb)

bindeb-pkg: FORCE
96
	$(MAKE) KBUILD_SRC=
R
Riku Voipio 已提交
97
	+$(call cmd,builddeb)
L
Linus Torvalds 已提交
98 99 100

clean-dirs += $(objtree)/debian/

P
Paolo Pisati 已提交
101 102 103 104 105 106 107 108 109 110 111 112 113 114 115
# snap-pkg
# ---------------------------------------------------------------------------
snap-pkg: FORCE
	rm -rf $(objtree)/snap
	mkdir $(objtree)/snap
	$(MAKE) clean
	$(call cmd,src_tar,$(KERNELPATH))
	sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
		s@SRCTREE@$(shell realpath $(KERNELPATH).tar.gz)@" \
		$(srctree)/scripts/package/snapcraft.template > \
		$(objtree)/snap/snapcraft.yaml
	cd $(objtree)/snap && \
	snapcraft --target-arch=$(UTS_MACHINE)

clean-dirs += $(objtree)/snap/
L
Linus Torvalds 已提交
116

117 118
# tarball targets
# ---------------------------------------------------------------------------
S
Sam Ravnborg 已提交
119
tar%pkg: FORCE
120
	$(MAKE) KBUILD_SRC=
121 122 123 124 125
	$(CONFIG_SHELL) $(srctree)/scripts/package/buildtar $@

clean-dirs += $(objtree)/tar-install/


126 127 128 129 130 131 132
# perf-pkg - generate a source tarball with perf source
# ---------------------------------------------------------------------------

perf-tar=perf-$(KERNELVERSION)

quiet_cmd_perf_tar = TAR
      cmd_perf_tar = \
133 134
git --git-dir=$(srctree)/.git archive --prefix=$(perf-tar)/         \
	HEAD^{tree} $$(cd $(srctree);                               \
135
		       echo $$(cat tools/perf/MANIFEST)) \
136
	-o $(perf-tar).tar;                                         \
137
mkdir -p $(perf-tar);                                               \
138
git --git-dir=$(srctree)/.git rev-parse HEAD > $(perf-tar)/HEAD;    \
139
(cd $(srctree)/tools/perf;                                          \
140
util/PERF-VERSION-GEN $(CURDIR)/$(perf-tar)/);              \
141
tar rf $(perf-tar).tar $(perf-tar)/HEAD $(perf-tar)/PERF-VERSION-FILE; \
142 143 144 145
rm -r $(perf-tar);                                                  \
$(if $(findstring tar-src,$@),,                                     \
$(if $(findstring bz2,$@),bzip2,                                    \
$(if $(findstring gz,$@),gzip,                                      \
146 147
$(if $(findstring xz,$@),xz,                                        \
$(error unknown target $@))))                                       \
148 149 150 151 152
	-f -9 $(perf-tar).tar)

perf-%pkg: FORCE
	$(call cmd,perf_tar)

L
Linus Torvalds 已提交
153 154
# Help text displayed when executing 'make help'
# ---------------------------------------------------------------------------
S
Sam Ravnborg 已提交
155
help: FORCE
156
	@echo '  rpm-pkg             - Build both source and binary RPM kernel packages'
R
Riku Voipio 已提交
157 158 159
	@echo '  binrpm-pkg          - Build only the binary kernel RPM package'
	@echo '  deb-pkg             - Build both source and binary deb kernel packages'
	@echo '  bindeb-pkg          - Build only the binary kernel deb package'
P
Paolo Pisati 已提交
160
	@echo '  snap-pkg            - Build only the binary kernel snap package (will connect to external hosts)'
161 162 163
	@echo '  tar-pkg             - Build the kernel as an uncompressed tarball'
	@echo '  targz-pkg           - Build the kernel as a gzip compressed tarball'
	@echo '  tarbz2-pkg          - Build the kernel as a bzip2 compressed tarball'
164
	@echo '  tarxz-pkg           - Build the kernel as a xz compressed tarball'
165 166 167
	@echo '  perf-tar-src-pkg    - Build $(perf-tar).tar source tarball'
	@echo '  perf-targz-src-pkg  - Build $(perf-tar).tar.gz source tarball'
	@echo '  perf-tarbz2-src-pkg - Build $(perf-tar).tar.bz2 source tarball'
168
	@echo '  perf-tarxz-src-pkg  - Build $(perf-tar).tar.xz source tarball'